#include <GL/glut.h>

//***************************************************************
// Some constants about the resolution of basic geometric object
// You can change them or remove them if you don't need them.
//***************************************************************
#define NUM_SIDES   20 
#define NUM_RINGS	20
#define NUM_SLICES	20
#define NUM_STACKS	20

//*****************************************************
//A gloabal GLUquadricObj object dynamically allocated 
//	for drawing GLU guadric objects in display() 
//*****************************************************
GLUquadricObj * ptrToQuadricInfo;



//***************************************************************
//You don't have to chnage the reshape function
//***************************************************************
//***************************************************************
//OpenGL commands to regenerate the scene saved in two functions:
//		display() and reshape( int w, int h)
//***************************************************************
void reshape(int w, int h)
{

 float left = -5.2;
 float right = 5.2;
 float bottom = -5.2;
 float top = 5.2;
 float near = 0.1;
 float far = 50;

 glMatrixMode(GL_PROJECTION);
 glLoadIdentity();

 if (w >= h)
     glOrtho( left * ( float(w)/ float(h)), right * ( float(w)/ float(h)),
              bottom, top,
              near, far
            );
 else
     glOrtho(  left , right , 
               bottom*( float(h)/ float(w)), top* ( float(h)/ float(w)),
               near, far
            );

 glMatrixMode(GL_MODELVIEW);


}



//***************************************************************
//You should add in your own code in this function 
//	to compose a static scene of at least 8 objects
//***************************************************************
void display()
{
 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

 //Select the ModelView matrix 
 glMatrixMode(GL_MODELVIEW);
 glLoadIdentity();


 //***************************************************
 // Set up ModelView Matrix by using
 //		glLookAt to set the camera location, viewing, and orientation.
 // You should modify the following according to your own setting
 //***************************************************
 gluLookAt
 ( -10.2474,	9.4019,	18.3102,	
	-3.99332,	4.65727,	10.367,	
	0,	1,	0
  );
 //View the object through the camera setting (step #4 ) 

 //***************************************************
 // Code to render geometric object 0
 // You should modify the following according to your own setting
 //***************************************************

 //Store the current setting of the model view matrix of the camera into the stack
 glPushMatrix();

 //Set the color
 // You should modify the following according to your own setting
 glColor3f(0,0.98,0.38);


 //Move the center of the object here (step #3 ) 
 // You should modify the following according to your own setting
 glTranslatef(1.4, 1.86265e-007, 0.5);

 //Rotate the object through X, Y, X axes  (step #2 ) 
 // You should modify the following according to your own setting
 glRotatef(23, 0.0, 0.0, 1.0);
 glRotatef(85, 0.0, 1.0, 0.0);
 glRotatef(-67, 1.0, 0.0, 0.0);

 //Scale the object along X, Y, X axes (step #1)
 // You should modify the following according to your own setting
 glScalef(3.05,3.05,1.4);

 //Compose the object through the steps#1~4 above
 // You should modify the following according to your own setting
 gluQuadricDrawStyle(ptrToQuadricInfo, GLU_LINE);
 gluDisk(ptrToQuadricInfo, 1, 1.2, NUM_SIDES, NUM_RINGS);


 //Restore the current setting of the model view matrix of the camera into the stack
 //	to cancel out the effecs of scaling, rotations, and translation
 glPopMatrix();


 //***************************************************
 // Code to render geometric object 1
 // You should modify the following according to your own setting
 //***************************************************
 // Add code to render one more object like what you see in the code segment for object 0 above.
 // ...



 //***************************************************
 // Code to render geometric object 2
 // You should modify the following according to your own setting
 //***************************************************
 // Add code to render one more object like what you see in the code segment for object 0 above.
 // ...



 //***************************************************
 // Code to render geometric object 3
 // You should modify the following according to your own setting
 //***************************************************
 // Add code to render one more object like what you see in the code segment for object 0 above.
 // ...



 //***************************************************
 // Code to render geometric object 4
 // You should modify the following according to your own setting
 //***************************************************
 // Add code to render one more object like what you see in the code segment for object 0 above.
 // ...


 //***************************************************
 // Code to render geometric object 5
 // You should modify the following according to your own setting
 //***************************************************
 // Add code to render one more object like what you see in the code segment for object 0 above.
 // ...


 //***************************************************
 // Code to render geometric object 6
 // You should modify the following according to your own setting
 //***************************************************
 // Add code to render one more object like what you see in the code segment for object 0 above.
 // ...


 //***************************************************
 // Code to render geometric object 7
 // You should modify the following according to your own setting
 //***************************************************
 // Add code to render one more object like what you see in the code segment for object 0 above.
 // ...

 //***************************************************
 // Flush out the buffer
 //***************************************************
 glFlush();
}
//************End of display function *****************


int main(int argc, char **argv)
{
 //***************************************************
 // Since this is only a static scene, we only use the default single buffer setting
 // If you want a dynamic scene, you should use double buffer.
 //***************************************************

 glutInit(&argc, argv);
 glutInitWindowSize(500, 500);
 glutCreateWindow("Snapshot of my Scene");
 glutReshapeFunc(reshape);
 glutDisplayFunc(display);
 glClearColor(0.0, 0.0, 0.0, 1.0);

 ptrToQuadricInfo = gluNewQuadric();
 glutMainLoop();
 return 0;
}

